#include "descriptor/descriptor.h"

int main(void) {

  ITEM  metronomo;
  ITEM  m_p_inf, m_p_a_s_d, m_p_s, m_c_a, m_p_p_r, m_a_p_p; //
  ITEM  m_a_p_g, m_p_g, m_p, m_a, m_p_p, m_p_a_d, m_p_a_s;  // parti metronomo
  ITEM  m_c_a_t, m_s_g;                                     //
  ITEM	piano, spartito, diapason;
  ITEM	spar_attr;
  ITEM  metr_col1, metr_col2, metr_col3, metr_pom, diap_col1, blu, yellow;
  ITEM	scene;

  set_background (0.1, 0.1, 0.1, TRUE);
  set_ambient_light (1, 1, 1, 0.8);
  create_point_light (10.0,9.0, 5.0,  0.5,0.5,0.5,  3.89,  20,  "light1");

  /*** ATTRIBUTE metronomo col1 ***/
  metr_col1 = create_attribute("marrone");
  set_color (metr_col1, 0.529, 0.2, 0.2,   0.4, 0.8);
  set_reflectivity (metr_col1, 0.85, 8);

  /*** ATTRIBUTE metronomo col2 ***/
  metr_col2 = create_attribute("marrone2");
  set_color (metr_col2, 0.55, 0.2, 0.2,   0.55, 0.8);
  set_reflectivity (metr_col2, 0.85, 8);

  /*** ATTRIBUTE metronomo col3 ***/
  metr_col3 = create_attribute("marrone3");
  set_color (metr_col3, 0.529, 0.2, 0.2,   0.3, 0.8);
  set_reflectivity (metr_col3, 0.85, 8);

  /*** ATTRIBUTE metronomo pomelli,asta,peso ***/
  metr_pom = create_attribute("pom");
  set_color (metr_pom, 0.41, 0.41, 0.41,   0.4, 0.9);
  set_reflectivity (metr_pom, 1.0, 1);

  /*** ATTRIBUTE diapason ***/
  diap_col1 = create_attribute("diap");
  set_color (diap_col1, 0.51, 0.51, 0.51,   0.4, 0.9);
  set_reflectivity (diap_col1, 1.0, 1);

  /* definizione SPARTITO */
  spar_attr = create_attribute("spar_attr");
  set_color(spar_attr, 1, 0.062, 0.031, 0.5, 0.5);
  set_reflectivity(spar_attr, 0.4, 2);

  /*** ATTRIBUTE blu ***/
  blu = create_attribute("blu");
  set_color (blu, 0.431, 0.458, 0.6, 0.2, 0.8);
  set_reflectivity (blu, 0.3, 10);

  /*** ATTRIBUTE yellow ***/
  yellow = create_attribute("yellow");
  set_color(yellow,1,1,0,0.2,0.8);
  set_reflectivity(yellow,0.3,10);


  /* definizione METRONOMO */
  m_p_inf   = read_nurbs("metr_parte_inferiore.db");
  m_p_a_s_d = read_nurbs("metr_parte_alta_senza_davanti.dbe");
  m_p_s     = read_nurbs("metr_punta_superiore.db");
  m_c_a_t   = read_nurbs("metr_chiusura_anteriore_trimmata.dbe");
  m_s_g     = read_nurbs("metr_scala_graduata.db");
  m_p_p_r   = read_nurbs("metr_pomello_piccolo_revol.db");
  m_a_p_p   = read_nurbs("metr_asta_pomello_piccolo.db");
  m_a_p_g   = read_nurbs("metr_asta_pomello_grande.db");
  m_p_g     = read_nurbs("metr_pomello_grande.db");
  m_a       = read_nurbs("metr_asta.db");
  m_p       = read_nurbs("peso_trimmato.dbe");
  m_p_p     = read_nurbs("metr_piede_posteriore.db");
  m_p_a_d   = read_nurbs("metr_piede_anter_des.db");
  m_p_a_s   = read_nurbs("metr_piede_anter_sin.db");
  set_attribute (m_p_inf, metr_col1);
  set_attribute (m_p_a_s_d, metr_col1);
  set_attribute (m_p_s, metr_col1);
  set_attribute (m_c_a_t, metr_col2);
  set_attribute (m_s_g, metr_pom);
  set_attribute (m_p_p_r, metr_pom);
  set_attribute (m_a_p_p, metr_pom);
  set_attribute (m_a_p_g, metr_pom);
  set_attribute (m_p_g, metr_pom);
  set_attribute (m_a, metr_pom);
  set_attribute (m_p, metr_pom);
  set_attribute (m_p_p, metr_col3);
  set_attribute (m_p_a_d, metr_col3);
  set_attribute (m_p_a_s, metr_col3);

  spartito  = read_nurbs("spartito.db");
  set_scale (spartito, 1.0/2.2, 1.0/1.5, 1.0/1.7);
  set_z_rotate (spartito, -101.0, 1);
  set_x_rotate (spartito, 90, 1);
  set_translate (spartito, -0.5, 0.0, 0.32);

  set_projection_texture (spartito, spar_attr, "textures/chopin.hr",
                          TRUE, TRUE, 0.6, 0.8);
  /* definizione DIAPASON */
  diapason = read_obj("diapason.obj", "diapason");
  set_attribute (diapason, diap_col1);

  /* definizione PIANO */
  piano = read_nurbs("piano2.db");
  set_attribute (piano, blu);

  /* crea lista oggetti della scena */
  scene = create_list (m_p_inf, "scene");
  scene = insert_in_list (scene, m_p_a_s_d);
  scene = insert_in_list (scene, m_p_s);
  scene = insert_in_list (scene, m_c_a_t);
  scene = insert_in_list (scene, m_s_g);
  scene = insert_in_list (scene, m_p_p_r);
  scene = insert_in_list (scene, m_a_p_p);
  scene = insert_in_list (scene, m_a_p_g);
  scene = insert_in_list (scene, m_p_g);
  scene = insert_in_list (scene, m_a);
  scene = insert_in_list (scene, m_p);
  scene = insert_in_list (scene, m_p_p);
  scene = insert_in_list (scene, m_p_a_d);
  scene = insert_in_list (scene, m_p_a_s);
  scene = insert_in_list (scene, spartito);
  scene = insert_in_list (scene, diapason);
  scene = insert_in_list (scene, piano);

  set_translate (spartito, 0.5, 0.0, -0.32);
  set_x_rotate (spartito, -90, 1);
  set_z_rotate (spartito, 101.0, 1);
  set_scale (spartito, 2.2, 1.5, 1.7);

  save_scene ("scena.md","scene_music", scene);
  return(0);
}
